import lang.stride.*;
import java.util.*;
import greenfoot.*;

/**
 * 
 */
public class Weltraum extends World
{

    private Color rasterfarbe = new Color(20, 20, 20, 60);
    private Peetie peetie;
    private int anzahlAsteroiden = 20;
    public int getAnzahlAsteroidenGesamt() { return this.anzahlAsteroiden; }
    private List<Gegner> anzahlGegnerAufWelt = new ArrayList<Gegner>();
    private int drohnenVerzoegerung = 60;
    private int drohnenCounter = this.drohnenVerzoegerung; // Verzögerung zwischen neu auftauchenden Drohnen
    private boolean alleDrohnenSindSchonDa = false; // wann werden keine Drohnen mehr gespawnt
    // private int gridSize = 50; // anpassen nach belieben; achtung, dann peeties groesse ändern! defaultwert = 50
    private String hintergrundBild = "weltraum_sterne_schwarz_1800x1200.jpg"; // anpassen bei Bedarf. Defaultbild marsoberflaeche-960.jpg
    private GreenfootImage gfiBG = this.getBackground();
    private int bgOriginalbreite = this.gfiBG.getWidth();
    private int bgOriginalhoehe = this.gfiBG.getHeight();
    private int hintergrundSkalierungscounterStart = 20;
    private int hintergrundSkalierungscounter = this.hintergrundSkalierungscounterStart;
    private double skalierungsWachstum = 1.0003;
    private double skalierungsfaktor = this.skalierungsWachstum;

    public Weltraum()
    {
        super(900, 600, 1);

        this.initializeWorld();
        this.bildAufOriginalgroesseSkalieren(); 
        
    
    }

    public void act() {
        if(this.hintergrundSkalierungscounter <= 0) {
            this.skalierungsfaktor = this.skalierungsfaktor * this.skalierungsWachstum;
            this.hintergrundSkalierungscounter = this.hintergrundSkalierungscounterStart;
            this.gfiBG = new GreenfootImage(this.hintergrundBild);
            this.bildAufOriginalgroesseSkalieren();

            this.gfiBG.scale((int)(this.gfiBG.getWidth() * this.skalierungsfaktor), (int)(this.gfiBG.getHeight() * this.skalierungsfaktor));

            this.setBackground(this.gfiBG);
        }
        this.hintergrundSkalierungscounter--;
        // this.drohnenSteuerung();
    }

    public void initializeWorld() {
        this.setBackground(this.hintergrundBild);
        this.gfiBG = this.getBackground();
        this.peetie = new Peetie();
        this.addObject(this.peetie, 1, 1);
        this.peetie.setImage("peetie_runter_50.png");
        this.objekteAufWeltSetzen();
        this.createUI();

    }

    public void objekteAufWeltSetzen()
    {
                   ErdeBG ebg= new ErdeBG();
        this.addObject(ebg, 611, 271); 
        Erde e = new Erde();
        this.addObject(e, 611, 271);
  
this.setPaintOrder(Label.class, Asteroid.class, Erde.class, ErdeBG.class);
   
        for(int i = 1; i <= this.anzahlAsteroiden; i++) {
            Asteroid a = new Asteroid();
            this.addObject(a, 1, 1);
        }
    }

    private void bildAufOriginalgroesseSkalieren() {
        this.gfiBG.scale(this.bgOriginalbreite, this.bgOriginalhoehe);

    }

    /*  public void drohnenSteuerung() {
    this.drohnenCounter--;
    if(this.drohnenCounter <= 0) {
    this.neueKampfDrohneAufWeltSetzen();
    // oder
    // this.neueScoutdrohneAufWeltSetzen();
    this.drohnenCounter = this.drohnenVerzoegerung;
    }
    if(((List<Gegner>)this.getObjects(Gegner.class)).size() <= 0 && this.alleDrohnenSindSchonDa) {
    this.showText("Alle Drohnen zerstört - sehr gut!!!", this.getWidth()/2, this.getHeight()/2);
    Greenfoot.stop();
    }

    } */

    public void asteroidenAbschussRegistrieren() {
        this.peetie.setAsteroidWurdeAbgeschossen(true);
    }

    /* public void neueScoutdrohneAufWeltSetzen() {
    if(((List<Gegner>)this.getObjects(Gegner.class)).size() <= 7 && !this.alleDrohnenSindSchonDa) {
    Scoutdrohne s = new Scoutdrohne();
    this.addObject(s, 70, 40);
    } else {
    this.alleDrohnenSindSchonDa = true;
    }
    } */

    public void neueKampfDrohneAufWeltSetzen() {
        if(((List<Gegner>)this.getObjects(Gegner.class)).size() <= 7 && !this.alleDrohnenSindSchonDa) {
            Kampfdrohne k = new Kampfdrohne();
            this.addObject(k, 50, 50);
        } else {
            this.alleDrohnenSindSchonDa = true;
        }
    }

    public void started() {
        Sound.play("BGMUSIC");
    }

    public void stopped() {
        Sound.stop("BGMUSIC");
    }

    public void createUI() {
        /* --------------- SOUND ---------------- */
        Sound.initializeDefaultSounds();

        /* --------------- BuTTONS ---------------- */
        // name, shortcut, filestandard, filehover, fileinactive

        Button btSound = new Button("ton", "t", "bt_soundON.png", "bt_soundON_clicked.png", "bt_soundOFF_inactive.png");
        this.addObject(btSound, 25, 575);

        Button btAnleitung = new Button("help", "h", "bt_help.png", "bt_help_clicked.png", null);
        this.addObject(btAnleitung, 65, 575);

        /* --------------- DIVERS (Logo …) ---------------- */
        Label logo = new Label();
        GreenfootImage g = new GreenfootImage("efm-logo-150x49.png");
        logo.setImage(g);
        this.addObject(logo, 90,30);

        /* --------------- RASTER ---------------- */
        //  this.createGrid();
    }

    public void alleShowTextTexteLoeschen() {
        for(int x = 1; x <= this.getWidth(); x++) {
            for(int y = 1; y <= this.getHeight(); y++) {
                this.showText("", x, y);
            }
        }
    }

}
